-module(bvPriority).

-include("eBhv3.hrl").

-export([tick/2]).

-spec tick(bt_node(), bt_state()) -> {bt_status(), bt_state()}.
tick(#{children := Children} = _BTNode, BTState) ->
   doTick(Children, BTState).

doTick([ChildID | T], BTState) ->
   case bvBaseNode:execute(ChildID, BTState) of
      {?BT_FAILURE, BTState1} ->
         doTick(T, BTState1);
      {BTStatus, BTState1} ->
         {BTStatus, BTState1}
   end;
doTick([], BTState) ->
   {?BT_FAILURE, BTState}.
